/***********************************************************************/
/* Device-Driver for pciGrabber-4, DOS Mode                            */
/*                                                                     */
/* *NOTE: DOS4GW DPMI-Interface required                               */
/*        Compiled with WATCOM C++ Compiler                            */
/*                                                                     */
/*                                                                     */
/* V0.0 -    03.97/U.T.                                                */
/* Revisions:                                                          */
/* V1.0 - 14.08.97/U.T. RELEASE VERSION                                */
/* V1.1 - 28.05.98/Kl   'PCI_Memory_Error' definiert                   */
/*                                                                     */
/*                                                                     */
/* Class: PCI                                                          */
/*                                                                     */
/* (c) 1997,98 PHYTEC Messtechnik GmbH Mainz                           */
/***********************************************************************/

#ifndef PCI_H
#define PCI_H

#define FINDDEVICE              0xB102
#define READCONFWORD            0xB109
#define WRITECONFWORD           0xB10C

#define PCI_SUCCESSFUL          0x00
#define PCI_BAD_VENDOR_ID       0x83
#define PCI_DEVICE_NOT_FOUND    0x86
#define PCI_BAD_REGISTER_NUMBER 0x87
#define PCI_SET_FAILED          0x88
#define PCI_BUFFER_TOO_SMALL    0x89

#define SUCCESSFUL              0
#define UNKNOWN_DEVICE_NUMBER   1
#define BAD_REGISTER_NUMBER     2
#define UNKNOWN_FIELD_TYPE      3
#define SIZE_NULL               4
#define RISC_MEMORY_ERROR       5
#define UNKNOWN_ERROR           99

#include "pci_dev.h"

class PCI
{
// private member-variables
private:
        unsigned long   m_nGPIO_Data ;
        unsigned short  m_nMaxDeviceNumber ;          
        

// public functions
public:
        PCI_DEVICE *m_pDeviceList ;
        PCI(unsigned short nVendorID,unsigned short nDeviceID) ;
        ~PCI() ;

        unsigned short Max_Device_Number(){return m_nMaxDeviceNumber ; } ;

        short Read_Config_Word(short nDevice_Number, short nCRegister_Number,
                                unsigned short *nContent) ;
        short Write_Config_Word(short nDevice_Number, short nCRegister_Number,
                                unsigned short nContent) ;
        short Read_Local_Byte(short nDevice_Number, short nLRegister_Number,
                                unsigned char *cContent) ;
        short Write_Local_Byte(short nDevice_Number, short nLRegister_Number,
                                unsigned char cContent) ;
        short Read_Local_Word(short nDevice_Number, short nLRegister_Number,
                                unsigned short *nContent) ;
        short Write_Local_Word(short nDevice_Number, short nLRegister_Number,
                                unsigned short nContent) ;
        short Read_Local_DWord(short nDevice_Number, short nLRegister_Number,
                                unsigned long *lContent) ;
        short Write_Local_DWord(short nDevice_Number, short nCRegister_Number,
                                unsigned long lContent) ;

} ;
#endif
